<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>大文件上传</title>
    <style>
        #progress{
            height:20px;
            width: 300px;
            margin-bottom: 30px;
        }
        #progress span{
            display: block;
            height:20px;
            width:0;
            color: #fff;
            font-size: 12px;
        }
        .red{
            background-color: red;
        }
        .green{
            background-color: green;
        }
    </style>
</head>
<body>
    <h1>大文文件分片上传  之 xhr formdata </h1>
    <div>
        选择文件:
        <input type="file" id="f1"/><br/><br/>
        <div id="progress">
            <span class="red"></span>
        </div>
        <button type="button" id="btn-submit">上 传</button>
    </div>
</body>
</html>
<script>
    //思路概括
    //把大文件分成每2m 一块进行上传，发送到服务器同时携带一个标志 暂时用当前的时间戳 ，
    //服务端生成临时文件，服务端接受一个文件结束的标志 ，然后将所有的文件进行合并成一个文件，清理临时文件。 返回结果（看情况）
    function submitUpload() {
        var chunkSize=2*1024*1024;//2m
        var progressSpan = document.getElementById('progress').firstElementChild;
        var file = document.getElementById('f1').files[0];
        var chunks=[],
        token = (+ new Date()),
        name =file.name,
        chunkCount=0,
        sendChunkCount=0;
        progressSpan.style.width='0';
        progressSpan.classList.remove('green');
        if(!file){
            alert('请选择文件');
            return;
        }
        //拆分文件
        if(file.size>chunkSize){
            //拆分文件
            var start=0,end=0;
            while (true) {
                end+=chunkSize;
                var blob = file.slice(start,end);
                start+=chunkSize;
                if(!blob.size){
                    //拆分结束
                    break;
                }
                chunks.push(blob);
            }
        }else{
            chunks.push(file.slice(0));
        }
        console.log(chunks);
        chunkCount=chunks.length;
        //没有做并发限制，较大文件导致并发过多，tcp 链接被占光 ，需要做下并发控制，比如只有4个在请求在发送
        for(var i=0;i< chunkCount;i++){
            var fd = new FormData();   //构造FormData对象
            fd.append('token', token);
            fd.append('f1', chunks[i]);
            fd.append('index', i);
            xhrSend(fd,function () {
                sendChunkCount+=1;
                if(sendChunkCount===chunkCount){
                    console.log('上传完成，发送合并请求');
                    var formD = new FormData();
                    formD.append('type','merge');
                    formD.append('token',token);
                    formD.append('chunkCount',chunkCount);
                    formD.append('filename',name);
                    xhrSend(formD);
                }
            });
        }
    }
    function xhrSend(fd,cb) {
        var xhr = new XMLHttpRequest();   //创建对象
        xhr.open('POST', 'http://localhost:8100/', true);
        xhr.onreadystatechange = function () {
            console.log('state change', xhr.readyState);
            if (xhr.readyState == 4) {
                console.log(xhr.responseText);
                cb && cb();
            }
        }
        var progressSpan = document.getElementById('progress').firstElementChild;
        xhr.onprogress = updateProgress;
        xhr.upload.onprogress = updateProgress;
        function updateProgress(event) {
            // console.log(event);
            if (event.lengthComputable) {
                var completedPercent = (event.loaded / event.total * 100).toFixed(2);
                console.log('22',progressSpan);
                progressSpan.style.width = completedPercent + '%';
                progressSpan.innerHTML = completedPercent + '%';
                if (completedPercent > 90) {//进度条变色
                    progressSpan.classList.add('green');
                }
                console.log('已上传', completedPercent);
            }
        }
        //注意 send 一定要写在最下面，否则 onprogress 只会执行最后一次 也就是100%的时候
        xhr.send(fd);//发送时  Content-Type默认就是: multipart/form-data; 
    }
    //绑定提交事件
    document.getElementById('btn-submit').addEventListener('click',submitUpload);
</script>